-- data Tree a = Node a [Tree a]
-- What does the following function (f) compute?
{- f tree
   PRE:     -
   RETURNS: 
   SIDE EFFECTS: -
   EXAMPLES:
    f (Node 2 [Node 5 [Node 7 []]])
      == [7,5,2]
-}
f (Node a tree) = fs tree ++ [a]
  where
    fs [] = []
    fs (t:ts) = f t ++ fs ts
-- some traversal of 'tree'?

-- -- The above definition of a 'tree' seems odd. Here is a more conventional definition:
-- data Tree a = Empty | Node a (Tree a) (Tree a) deriving (Show)
-- -- Taken from http://learnyouahaskell.com/zippers#taking-a-walk
