-- data Exceptional e a = Success a | Exception e deriving (Show)
-- -- throw :: Exception -> Exceptional a
-- throw :: e -> Exceptional e a
-- throw = Exception

data Exception = DivideByZeroException
type Exceptional a = Either Exception a

throw = Exception

-- {- a /// b
--    PRE:     -
--    RETURNS: 
--    SIDE EFFECTS: -
--    EXAMPLES:
--     3 /// 1
--       == 3
-- -}
-- (///) :: Int -> Int -> Exceptional Int
-- _ /// 0 = throw DivideByZeroException
-- a /// b = return (a `div` b)

-- {- foo a b c
--    PRE:     -
--    RETURNS: 
--    SIDE EFFECTS: -
--    EXAMPLES:
--     foo 3 2 1
--       == 
-- -}
-- foo :: Int -> Int -> Int -> Exceptional Int
-- foo a b c = do
--     e <- a /// b
--     c /// e
-- 
-- {- bar a b c 
--    PRE:     -
--    RETURNS: 
--    SIDE EFFECTS: -
--    EXAMPLES:
--     bar 3 2 1
--       == 
--     bar 0 2 1
--       == 
-- -}
-- bar :: Int -> Int -> Int -> Int
-- bar a b c = handler c (foo a b c)
--     where
--     handler :: Int -> Exceptional Int -> Int
--     handler d exc =
--         case exc of
--             Right y -> if y < 0 then -1 else y
--             Left _ -> d
